// init fast click
$(function () {
  FastClick.attach(document.body);
});

// 整理一些常用函数
(function (window) {
  var cbID = 0;

  // 把回调函数绑定到window上
  function changeCallback(params) {
    var successCb = params.success;
    // token 过期 拦截success
    if (params.name === "request") {

      if (params.success) {
        params.success = function (ret) {
          //successCb(ret);
          successCb(ret);
        }
      } else {
        params.success = function (ret) {
          successCb(ret);
        }
      }
    }

    var cbs = ["success", "cancel", "error", "complete", "action"]; // 可能有的回调函数
    _.each(cbs, function (cb) {
      if (params[cb]) {
        var cbName = "cb" + (++cbID),
          realCb = params[cb];

        params[cb] = cbName;
        window[cbName] = function (data) {
          if (typeof data === "string") {
            data = decodeURIComponent(data);

            if (/^\{.*\}$/.test(data)) {
              data = $.parseJSON(data);
            }
          }
          realCb(data);

          // setToolbar 的button params 没有name 属性  并且事件是可以多次点击  不用删除
          if (cb !== "action") {
            delete window[cbName];
          }
        }
      }
    });
  }

  function callBrick(params) {

    if (_.isObject(params)) {

      // setToolbar 需要特殊处理一下 他的action 在buttons里面
      if (params.name === "setToolbar" && params.buttons && params.buttons.length) {
        if (!window.isSetToolbar) {
          // set toolbar  只绑定一次
          window.isSetToolbar = true;
          _.each(params.buttons, function (button) {
            changeCallback(button);
          });
        } else {
          return false;
        }
      } else if (params.name === "setRightNavigationButton") {
        // 也只绑一次
        if (!window.isSetRightNavigationButton) {
          window.isSetRightNavigationButton = true;
          changeCallback(params)
        } else {
          return false;
        }
      } else {
        changeCallback(params)
      }
    }

    var iframe = document.createElement('iframe'),
      parameters = _.isObject(params) ? JSON.stringify(params) : params

    console.log(parameters);
    iframe.setAttribute('src', 'js://' + encodeURIComponent(parameters));
    document.documentElement.appendChild(iframe);
    iframe.parentNode.removeChild(iframe);
    iframe = null;
  }

  /*  // 使用说明
   xqBridge.confirm({
   title: "确认取消关注？",
   // 成功回调
   success: function () {
   alert("success");
   },
   // 取消回调
   cancel: function () {
   alert("cancel");
   },
   // 错误回调
   error: function () {
   alert("error");
   }
   });*/

  // 事件
  window.eventObj = {};

  window.xqBridge = {
    /**
     * 显示loading view
     */
    showLoading: function () {
      callBrick("showloading");
    },

    /**
     * 隐藏loading view
     */
    hideLoading: function () {
      callBrick("hideloading");
    },

    /**
     * alert view
     * @param options
     */
    alert: function (options) {
      if (options && _.isObject(options)) {
        options.name = "alert";
      }
      callBrick(options);
    },

    datePicker: function (options) {
      if (options && _.isObject(options)) {
        options.name = "datePicker";
      }
      callBrick(options);
    },

    /**
     * error view
     * @param options
     */
    error: function (options) {
      if (options && _.isObject(options)) {
        options.name = "error";
      }
      callBrick(options);
    },

    /**
     * confirm view
     * @param options
     * @returns {*}
     */
    confirm: function (options) {
      if (options && _.isObject(options)) {
        options.name = "confirm";
      }
      callBrick(options);
    },

    /**
     * 发送作品
     * @param options
     */
    composePhotoWork: function (options) {
      if (options && _.isObject(options)) {
        options.name = "composePhotoWork";
      }
      callBrick(options);
    },

    /**
     *
     * @param options
     * options 同ajax options
     * 先不包成promise了
     */
    request: function (options) {
      if (options && _.isObject(options)) {
        options.name = "request";

        if (_.isUndefined(options.type)) {
          options.type = "GET";
        }
      }

      callBrick(options);
    },

    /**
     * @param options
     * 接口说明：页面跳转
     * 输入: js://{name: "redirect", url: "/newurl", type: "PUSH/POP/MODAL/CLOSE",callback: "callbackfunction", callbackData: {}}
     * 参数说明：
     * url：可以是相对 url（雪球内部 url） 也可以是绝对 url，可选（POP 和 CLOSE 的时候不需要 url）
     * callback: PUSH 和 MODAL 的时候可以带 callback 方法，当 push 和 modal 的 view 关闭的时候执行，方法带的参数是 POP 和 CLOSE 命令里带的 callbackData
     * type=PUSH 推进 nav 栈
     * type=POP 关闭页面，回到 nav 上一个页面
     * type=MODAL 开新模态页面
     * type=CLOSE 关闭当前页面所在的模态页面
     */
    redirect: function (options) {
      if (options && _.isObject(options)) {
        options.name = "redirect";
      }

      callBrick(options);
    },

    /**
     *
     * {name:"setToolbar", buttons: [{title: "button1", action: "button1_action", icon: "icon1_url", hightlight: true}]}
     * @param options
     * buttons 数组
     * 每个 button 内部的参数:
     * tittle: button 的文字
     * action: 点击 button 的事件
     * icon: button 文字前面的小图标 url（可选）
     * highlight: 是否是蓝底白字，比如「交易」，（可选，默认是否）
     */
    setToolbar: function (options) {
      if (options && _.isObject(options)) {
        options.name = "setToolbar";
      }

      callBrick(options);
    },

    /**
     * 获取当前用户的access_token
     * @param options
     */
    getAccessToken: function (options) {
      if (options && _.isObject(options)) {
        options.name = "getAccessToken";
      }

      callBrick(options);
    },

    /**
     * 获取指定绑定券商的写token
     * {aid:aid}
     * @param options
     */
    getWriteToken: function (options) {
      if (options && _.isObject(options)) {
        options.name = "getWriteToken";
      }

      callBrick(options);
    },

    /**
     * 获取当前用户的userInfo
     * @param options
     */
    getUserInfo: function (options) {
      if (options && _.isObject(options)) {
        options.name = "getUserInfo";
      }

      callBrick(options);
    },

    /**
     * 接口说明：设置页面 toolbar
     * 输入：js://{name:"setToolbar", buttons: [{title: "button1", action: "button1_action", icon: "icon1_url", hightlight: true}, {title: "button2", action: "button2_action", icon: "icon2_url", hightlight: false}]}
     * 参数说明：
     * buttons 是一个 array
     * 每个 button 内部的参数:
     * tittle: button 的文字
     * action: 点击 button 的事件
     * icon: button 文字前面的小图标 url（可选）
     * highlight: 是否是蓝底白字，比如「交易」，（可选，默认是否）
     * @param options
     */
    setToolbar: function (options) {
      if (options && _.isObject(options)) {
        options.name = "setToolbar";
      }

      callBrick(options);
    },

    /**
     * 接口说明：设置页面右上角按钮
     * 输入： js://{name: "setRightNavigationButton", title: "下一个页面", action: 'callback'}
     * @param options
     */
    setRightNavigationButton: function (options) {
      if (options && _.isObject(options)) {
        options.name = "setRightNavigationButton";
      }

      callBrick(options);
    },
    on: function (event, callback) {
      var array = eventObj[event];

      if (array) {
        array.push(callback);
      } else {
        array = [callback];
        eventObj[event] = array;
      }
    },
    off: function (event, callback) {
      if (callback) {
        var array = eventObj[event];

        if (array && array.length) {
          array = _.reject(array, function (fn) {
            return fn == callback;
          });
        }
      } else {
        delete eventObj[event];
      }
    },
    trigger: function (event) {
      var array = eventObj[event];

      if (array && array.length) {
        _.each(array, function (fn) {
          fn();
        });
      }
    }
  };

  window.Util = {

    /**
     * 验证密码
     * @param options
     * url 密码过期  接口会返回验证密码的url
     * success 验证成功 回调
     * cancel 取消验证 回调
     */
    verifyPassword: function (options) {

      xqBridge.redirect({
        url: options.url,
        type: "MODAL",
        success: options.success,
        cancel: options.cancel
      });
    },

    getAndRefreshToken: function (options) {
      xqBridge.getWriteToken({
        aid: options.aid,
        success: function (token) {
          if (token) {
            options.success && options.success(token);
          } else {
            xqBridge.redirect(
              {
                url: "/broker/proxy?url=" + encodeURIComponent(options.renew_url),
                type: 'MODAL',
                success: function () {
                  xqBridge.getWriteToken({
                    aid: options.aid,
                    success: function (token) {
                      options.success && options.success(token);
                    }
                  })
                },
                cancel: function (e) {
                  options.error && options.error(e);
                }
              })
          }
        }
      })
    },


    /**
     * 解析query字符串为对象
     * @param query
     * @returns {{}}
     */
    parseParams: function () {
      var href = window.location.href,
        array = href.split("?"),
        query = "";

      if (array.length === 1) {
        return {};
      } else {
        query = _.last(array);
      }

      // parseParams
      var re = /([^&=]+)=?([^&]*)/g;
      var decodeRE = /\+/g;  // Regex for replacing addition symbol with a space
      var decode = function (str) {
        return decodeURIComponent(str.replace(decodeRE, " "));
      };

      query = decodeURIComponent(query);
      var params = {},
        e;

      while (e = re.exec(query)) {
        var k = decode(e[1]),
          v = decode(e[2]);

        if (k.substring(k.length - 2) === '[]') {
          k = k.substring(0, k.length - 2);
          (params[k] || (params[k] = [])).push(v);
        } else {
          params[k] = v;
        }
      }
      return params;
    },

    showError: function (str) {
      var $error = $(".error-tip"),
        length = str.length,
        textWidth = length * 14,
        divWidth = textWidth + 20,
        scrollTop = $(window).scrollTop(),
        windowHeight = $(window).height();

      if (!$error.length) {
        $("body").append('<div class="error-tip"></div>');
        $error = $(".error-tip");
      }

      $error.css({
        "width": divWidth + "px",
        "margin-left": "-" + divWidth / 2 + "px",
        "top": scrollTop + windowHeight / 2 + "px"
      });

      $error
        .text(str)
        .show();

      setTimeout(function () {
        $error.hide();
      }, 1500);
    },
    setPress: function (selector, pressClass) {
      var $body = $("body");
      var startEvent = "touchstart";
      var endEvent = "touchend";
      var moveEvent = "touchmove";

      if (!'ontouchstart' in document.documentElement) {
        startEvent = "mousedown";
        endEvent = "mouseup";
        moveEvent = "mousemove";
      }

      var isMove = false;

      $body.on(startEvent, selector, function () {
        var $el = $(this);

        setTimeout(function () {
          if (!isMove && !$el.hasClass(pressClass)) {
            $el.addClass(pressClass);
            $el.data("nopress", false);
          }
        }, 100);
      });

      $body.on(moveEvent, selector, function () {
        var $el = $(this);
        isMove = true;
        $el.removeClass(pressClass);
      });

      $body.on(endEvent, selector, function () {
        var $el = $(this);

        setTimeout(function () {
          isMove = false;
          $el.removeClass(pressClass);
        }, 200);
      });

      if (navigator.userAgent.indexOf("iPhone") == -1) {
        $body.on(endEvent, function () {
          isMove = false;
        });
      }
    }
  };

  // 需要前置初始化的项
  baseInit = function () {
    window.userInfo = {};

    window.viewDidAppear = function () {

    };
    window.viewDidDisappear = function () {

    };

    window.updateTryCount = function () {

    };

    xqBridge.getUserInfo({
      success: function (userInfo) {
        if (userInfo) {
          window.userInfo = userInfo;
        } else {
          window.userInfo = {};
        }
      },
      error: function (e) {

      }
    });
  };

  baseInit()
})(window);

$(function () {
  Number.prototype.formatMoney = function (c, d, t) {
    var n = this,
      c = isNaN(c = Math.abs(c)) ? 2 : c,
      d = d == undefined ? "." : d,
      t = t == undefined ? "," : t,
      s = n < 0 ? "-" : "",
      i = parseInt(n = Math.abs(+n || 0).toFixed(c)) + "",
      j = (j = i.length) > 3 ? j % 3 : 0;
    return s + (j ? i.substr(0, j) + t : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : "");
  };
});
